/* log.h  --  Error and warning messages.
 *
 *  Copyright (C) 2016 Tomasz Kramkowski <tk@the-tk.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */
#ifndef LOG_H
#define LOG_H

#include <stdnoreturn.h>

#define EMSG_ALLOC "Could not allocate memory"
#define EMSG_OPEN "Could not open '%s'"
#define EMSG_READ "Could not read '%s'"
#define EMSG_SZOP "Arithmetic operation on size_t would wrap"
#define EMSG_GNOMEM "A call to glob ran out of memory"

extern const char *argv0;

noreturn void error(int errnum, const char *fmt, ...)
	__attribute__ ((format(printf, 2, 3)));
noreturn void errorat(int errnum, const char *file, long line, const char *fmt, ...)
	__attribute__ ((format(printf, 4, 5)));

void warning(int errnum, const char *fmt, ...)
	__attribute__ ((format(printf, 2, 3)));
void warningat(int errnum, const char *file, long line, const char *fmt, ...)
	__attribute__ ((format(printf, 4, 5)));

#endif /* LOG_H */
